/*
 * Copyright (C) 1990 by the University of Illinois Board of Trustees.
 * 
 * This code is distributed in the hope that it will be useful,
 * but without any warranty.  No author or distributor accepts
 * responsibility to anyone for the consequences of using it or for
 * whether it serves any particular purpose or works at all, unless
 * s/he says so in writing.
 * 
 * Everyone is granted permission to copy, modify and redistribute
 * this code under the following conditions:
 * 
 *    Permission is granted to anyone to make or distribute copies
 *    of program source code, either as received or modified, in any
 *    medium, provided that all copyright notices, permission and
 *    nonwarranty notices are preserved, and that the distributor
 *    grants the recipient permission for further redistribution as
 *    permitted by this document, and gives him and points out to
 *    him an exact copy of this document to inform him of his rights.
 * 
 *    Permission is granted to distribute this code in compiled
 *    or executable form under the same conditions applying for
 *    source code, provided that either
 *    A. it is accompanied by the corresponding machine-readable
 *       source code, or
 *    B. it is accompanied by a written offer, with no time limit,
 *       to give anyone a machine-readable copy of the corresponding
 *       source code in return for reimbursement of the cost of
 *       distribution.  This written offer must permit verbatim
 *       duplication by anyone.
 *    C. it is distributed by someone who received only the
 *       executable form, and is accompanied by a copy of the
 *       written offer of source code which he received along with it.
 * 
 * In other words, you are welcome to use, share and improve this
 * code.  You are forbidden to forbid anyone else to use, share
 * and improve what you give them.   Help stamp out software-hoarding!
*/
#ifndef lint
static char rcsid[] = "@(#) $Header: /home/poona/hollings/src/nwxmap/RCS/bsearch.c,v 1.1 1991/12/10 16:51:29 hollings Exp $";
#endif

/*
 * $Log: bsearch.c,v $
 * Revision 1.1  1991/12/10  16:51:29  hollings
 * Initial revision
 *
 */


char *bisearch(key, base, nel, keysize, compar)
char *base;
int nel;
register int (*compar)();
register char *key;
register int keysize; {

    register int l = 0, h = nel - 1, m, r;

    while (h >= l) {
	m = (l + h) >> 1;
	r = (*compar)(base+keysize*m, key);
	if (r > 0) h = m - 1;
	else if (r < 0) l = m + 1;
	else return base+keysize*m;
	}
    return 0;
    }
