
/*
 * Copyright (C) 1990 by the University of Illinois Board of Trustees.
 * 
 * This code is distributed in the hope that it will be useful,
 * but without any warranty.  No author or distributor accepts
 * responsibility to anyone for the consequences of using it or for
 * whether it serves any particular purpose or works at all, unless
 * s/he says so in writing.
 * 
 * Everyone is granted permission to copy, modify and redistribute
 * this code under the following conditions:
 * 
 *    Permission is granted to anyone to make or distribute copies
 *    of program source code, either as received or modified, in any
 *    medium, provided that all copyright notices, permission and
 *    nonwarranty notices are preserved, and that the distributor
 *    grants the recipient permission for further redistribution as
 *    permitted by this document, and gives him and points out to
 *    him an exact copy of this document to inform him of his rights.
 * 
 *    Permission is granted to distribute this code in compiled
 *    or executable form under the same conditions applying for
 *    source code, provided that either
 *    A. it is accompanied by the corresponding machine-readable
 *       source code, or
 *    B. it is accompanied by a written offer, with no time limit,
 *       to give anyone a machine-readable copy of the corresponding
 *       source code in return for reimbursement of the cost of
 *       distribution.  This written offer must permit verbatim
 *       duplication by anyone.
 *    C. it is distributed by someone who received only the
 *       executable form, and is accompanied by a copy of the
 *       written offer of source code which he received along with it.
 * 
 * In other words, you are welcome to use, share and improve this
 * code.  You are forbidden to forbid anyone else to use, share
 * and improve what you give them.   Help stamp out software-hoarding!
*/
#ifndef lint
static char rcsid[] = "@(#) $Header: /home/poona/hollings/src/nwxmap/RCS/product.c,v 1.1 1991/12/10 16:51:29 hollings Exp $";
#endif

/*
 * $Log: product.c,v $
 * Revision 1.1  1991/12/10  16:51:29  hollings
 * Initial revision
 *
 */

#include <X11/Intrinsic.h>
#include "map.h"

#define streq !strcmp


char *doprod(s) 
char *s; 
{
    static char *pagername = NULL;
    char *getenv();
    char buf[120];
    static char tmpFile[120];
    FILE *pagerpipe, *popen();
    
    /*
    ** Request the product and see if the server is going
    ** to give it to us.
    */
    sprintf(buf, "PROD %s\n", s);
    requestServerData(buf);
    readServerData(buf, sizeof buf);
    if (buf[0] != '1') {
	return(NULL);
    }
    
    /*
    ** Oh good, it is. Remember it ends with a single period,
    ** just like everything else. First figure out what our pager
    ** is gonig to be, though.
    */
    strcpy(tmpFile, "/tmp/wxMapXXXXXX");
    (void) mktemp(tmpFile);

    /*
    ** Now try to set up a temp file.
    */
    if ((pagerpipe = fopen(tmpFile, "w")) == NULL) {
	char message[80];

	sprintf(message, "Couldn't set up temp file, %s\n", tmpFile);
	ErrorWindow(message);

	/* eat responce from server */
	while (readServerData(buf, sizeof buf) != NULL) {
	    if (buf[0] == '.' && buf[1] == '\n') break;
	}
	return(NULL);
    }

    while (readServerData(buf, sizeof buf) != NULL) {
	if (buf[0] == '.' && buf[1] == '\n') break;
	fputs(buf, pagerpipe);
    }
    fflush(pagerpipe);
    fclose(pagerpipe);
    if (buf[0] != '.') {
	ErrorWindow("Server Connection lost");
	return(NULL);
    }
    return(tmpFile);
}
